<template>
	<div class="transactions-table">
		<div class="text-center">
			<div class="text-center section-title">
				<h4>{{ __("Bank Transactions") }}</h4>
			</div>
			<div>
				<div class="btn-group" role="group" aria-label="...">
					<button
						v-for="(filter, i) in [
							{ value: 'All', label: __('All') },
							{ value: 'Unreconciled', label: __('Unreconciled') },
							{ value: 'Reconciled', label: __('Reconciled') },
						]"
						:key="i"
						type="button"
						class="btn"
						:class="list_filter == filter.value ? 'btn-secondary-dark' : 'btn-default'"
						@click="change_filter(filter)"
					>
						{{ filter.label }}
					</button>
				</div>
			</div>
		</div>
		<div class="transactions-table">
			<div ref="transactionslist"></div>
		</div>
		<div class="text-center document-options">
			<div class="btn-group" role="group" aria-label="Bank Transactions Options">
				<button type="button" class="btn btn-default" @click="auto_reconciliation">
					{{ __("Automatic reconciliation") }}
				</button>
				<button v-if="selected_transactions.length" type="button" class="btn btn-primary" @click="make_journal_entry">
					{{ __("Match with a new journal entry") }}
				</button>
			</div>
		</div>
	</div>
</template>

<script setup>
import { ref, onMounted, watch } from 'vue'
import { TabulatorFull as Tabulator } from 'tabulator-tables';

const props = defineProps({
	bank_account: {
		type: String,
		default: null
	},
	start_date: {
		type: String,
		default: null
	},
	end_date: {
		type: String,
		default: null
	},
	selected_transactions: {
		type: Array,
		default: () => []
	}
})

const transactionslist = ref(null);
const tabulator = ref(null);
const tableData = ref([]);
const list_filter = ref("Unreconciled")

function get_transaction_list() {
	if (props.bank_account && props.start_date && props.end_date) {
		const query_filters = [
			["Bank Transaction", "bank_account", "=", props.bank_account],
			["Bank Transaction", "date", "between", [props.start_date, props.end_date]],
			["Bank Transaction", "docstatus", "=", 1]
		]

		if (list_filter.value == "Unreconciled") {
			query_filters.push(["Bank Transaction", "unallocated_amount", "!=", 0])
		} else if (list_filter.value == "Reconciled") {
			query_filters.push(["Bank Transaction", "unallocated_amount", "=", 0])
		}

		return frappe.xcall('frappe.client.get_list', {
			doctype: "Bank Transaction",
			order_by: "date DESC",
			fields: ["name", "date", "currency", "debit", "credit", "description", "allocated_amount", "unallocated_amount", "bank_account"],
			filters: query_filters,
			limit_page_length: 500,
			limit_start: 0
		}).then(r => {
			const mapped_transactions = r.map(transaction => ({
				...transaction,
				amount: transaction.unallocated_amount,
				link: frappe.utils.get_form_link("Bank Transaction", transaction.name)
			}))

			tableData.value = mapped_transactions;
		})
	}
}

function change_filter(filter) {
	list_filter.value = filter.value;
	get_transaction_list()
}

function auto_reconciliation() {
	frappe.show_alert({ message: __(`Automatic reconciliation in progress`), indicator: "green" })
	frappe.xcall('erpnext.accounts.page.bank_reconciliation.auto_bank_reconciliation.auto_bank_reconciliation',
		{ bank_transactions: tableData.value }
	).then(() => {
		get_transaction_list()
	})
}

async function make_journal_entry() {
	let data = [];
	const bank_account_gl = await frappe.db.get_value("Bank Account", props.bank_account, "account");
	const dialog = new frappe.ui.Dialog({
		size: "large",
		fields: [
			{
				fieldname: "journal_entry_template",
				fieldtype: "Link",
				options: "Journal Entry Template",
				label: __("Journal Entry Template"),
				reqd: 1,
				onchange: () => {
					const values = dialog.get_values()
					update_preview_table(values)
				},
				get_query: () => ({
					query: "erpnext.accounts.doctype.journal_entry_template.journal_entry_template.get_bank_journal_entry_template",
					filters: {
						bank_account: bank_account_gl.message.account
					}
				})
			},
			{
				fieldname: "journal_entry_preview",
				fieldtype: "Table",
				label: __("Journal Entry"),
				get_data: () => {
					return data;
				},
				in_place_edit: true,
				cannot_add_rows: true,
				fields: [
					{
						fieldname: "account",
						fieldtype: "Link",
						options: "Account",
						label: __("Account"),
						in_list_view: 1
					},
					{
						fieldname: "debit",
						fieldtype: "Currency",
						label: __("Debit"),
						in_list_view: 1,
						change: function() {
							set_totals()
						}
					},
					{
						fieldname: "credit",
						fieldtype: "Currency",
						label: __("Credit"),
						in_list_view: 1,
						change: () => {
							set_totals()
						}
					},
				]
			},
			{
				fieldname: "section_break",
				fieldtype: "Section Break",
			},
			{
				fieldname: "debit",
				fieldtype: "Currency",
				label: __("Total Debit"),
				read_only: 1
			},
			{
				fieldname: "column_break",
				fieldtype: "Column Break",
			},
			{
				fieldname: "credit",
				fieldtype: "Currency",
				label: __("Total Credit"),
				read_only: 1
			},
		],
		title: __("Make a new entry and reconcile it"),
		primary_action_label: __("Create and reconcile"),
		primary_action: () => {
			set_totals();
			const values = dialog.get_values()
			if (values.debit != values.credit) {
				frappe.show_alert(
					{
						message: __(`Total debit should be equal to total credit`),
						indicator: "green"
					}
				)
				return
			}


			frappe.call({
				method: "erpnext.accounts.page.bank_reconciliation.bank_reconciliation.make_journal_entry_and_reconcile",
				args: {
					template: dialog.get_values(),
					bank_account: props.bank_account,
					transactions: props.selected_transactions
				}
			}).then(() => {
				frappe.show_alert(
					{
						message: __(`Voucher created and automatically reconciled`),
						indicator: "green"
					}
				)
				get_transaction_list()
			})
			dialog.hide();
		}
	});
	dialog.show();

	const update_preview_table = async(values) => {
		data = []
		if (!values.journal_entry_template) {
			dialog.fields_dict.journal_entry_preview.grid.refresh();
			return
		}

		await frappe.model.with_doctype("Journal Entry Template");
		await frappe.model.with_doc("Journal Entry Template", values.journal_entry_template);
		const doc = frappe.get_doc("Journal Entry Template", values.journal_entry_template);

		let total_allocated = false
		const total_amount = props.selected_transactions.reduce((prev, curr) => prev + curr.amount, 0.0)

		doc.accounts.forEach(row => {
			if (bank_account_gl.message.account == row.account) {
				data.push({
					account: row.account,
					debit: total_amount > 0 ? Math.abs(total_amount) : 0.0,
					credit: total_amount < 0 ? Math.abs(total_amount) : 0.0
				})
			} else {
				data.push({
					account: row.account,
					debit: total_amount < 0 && !total_allocated ? Math.abs(total_amount) : 0.0,
					credit: total_amount > 0 && !total_allocated ? Math.abs(total_amount) : 0.0
				})
				if (!total_allocated) {
					total_allocated = true
				}
			}
		})
		set_totals();
		dialog.fields_dict.journal_entry_preview.grid.refresh();
	}


	const set_totals = () => {
		const values = dialog.get_values()
		dialog.set_value("debit", values.journal_entry_preview.reduce((prev, curr) => prev + curr.debit, 0.0))
		dialog.set_value("credit", values.journal_entry_preview.reduce((prev, curr) => prev + curr.credit, 0.0))
	}
}

const emit = defineEmits(['transactionsChange'])
function onSelectedRowsChange() {
	var selectedData = tabulator.value.getSelectedData();
	emit('transactionsChange', selectedData)
}

const columns = [
	{
		formatter: "rowSelection",
		titleFormatter: "rowSelection",
		cssClass: "text-center",
		titleFormatterParams: {
			rowRange: "active"
		},
		hozAlign: "center",
		headerSort: false,
	},
	{
		widthGrow: 2,
		title: __("Date"),
		field: "date",
		formatter(cell, formatterParams, onRendered) {
			const cellValue = cell.getValue();

			if (!cellValue) {
				return null;
			}

			return frappe.datetime.str_to_user(cellValue)
		},
	},
	{
		widthGrow: 6,
		title: __("Description"),
		field: "description",
		formatter: "html",
		headerFilter: "input",
		headerSort: false,
		headerFilterPlaceholder: __("Description"),
		titleFormatter: () => "",
	},
	{
		widthGrow: 2,
		title: __("Amount"),
		field: "amount",
		formatter(cell, formatterParams, onRendered) {
			const cellValue = cell.getValue();
			const row = cell.getRow();
			const cellRowData = row.getData();

			if (!cellValue) {
				return null;
			}

			return format_currency(cellValue, cellRowData.currency)
		},
	},
	{
		title: __("Link"),
		field: 'link',
		headerSort: false,
		formatter(cell, formatterParams, onRendered) {
			const cellValue = cell.getValue();

			if (!cellValue) {
				return null;
			}

			return `<a href="${cellValue}" target="_blank"><i class='uil uil-external-link-alt'></i></a>`
		}
	}
]

onMounted(() => {
	const tabulatorInstance = new Tabulator(transactionslist.value, {
		data: tableData.value,
		columns: columns,
		selectable: true,
		pagination: true,
		paginationSize: 20,
		paginationSizeSelector: [10, 20, 50, 100, true],
		placeholder: __("No data available for this period"),
		locale: true,
		layout: "fitColumns",
		langs: {
			"default": {
				"pagination": {
					"page_size": __("Page Size"),
					"page_title": __("Show Page"),
					"first": __("First"),
					"first_title": __("First Page"),
					"last": __("Last"),
					"last_title": __("Last Page"),
					"prev": __("Prev"),
					"prev_title": __("Prev Page"),
					"next": __("Next"),
					"next_title": __("Next Page"),
					"all": __("All"),
					"counter": {
						"showing": __("Showing"),
						"of": __("of"),
						"rows": __("rows"),
						"pages": __("pages"),
					}
				},
			}
		},
	});

	tabulator.value = tabulatorInstance;

	tabulatorInstance.on("rowSelectionChanged", function (data, rows, selected, deselected) {
		onSelectedRowsChange()
	});

	get_transaction_list()
})

watch(() => [props.bank_account, props.start_date, props.end_date], () => {
	get_transaction_list()
});

watch(tableData, (newData, oldData) => {
	tabulator.value.replaceData(newData);
})

defineExpose({
	get_transaction_list
})

</script>

<style lang='scss'>
.transactions-table {
	margin-bottom: 50px;
	margin-top: 1rem;

	.section-title {
		border-bottom: 1px solid #d1d8dd;
		margin-bottom: 10px;
		text-transform: uppercase;
	}
}

.no-data {
	margin: 25px;
	height: 150px;
}
</style>
